/* DO NOT EDIT!  -*- buffer-read-only: t -*-  vi:set ro:                                                                                                                   
 * This file is automatically generated from MDS description
 */

/* KVX ELF IDs definitions.
 *
 * Copyright (C) 2009-2020 Kalray SA.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* This file holds definitions specific to the KV3 ELF IDs. */

#ifndef _KV3_ELFIDS_H_
#define _KV3_ELFIDS_H_

/* 	 16.15 	  8.7  4.3  0 */
/* +----------------------------+ */
/* |      CUT | CORE  |PIC |ABI | */
/* +----------------------------+ */


#define KVX_CUT_MASK 0x00ff0000
#define KVX_CORE_MASK 0x0000ff00
#define KVX_ABI_MASK 0x000000ff
#define KVX_MACH_MASK (KVX_CUT_MASK | KVX_CORE_MASK | KVX_ABI_MASK)

/*
 * Machine private data :
 * - byte 0 = ABI specific (PIC, OS, ...)
 *   - bit 0..3 = ABI ident
 *   - bit 4    = 32/64 bits addressing
 *   - bit 5    = PIC
 * - byte 1 = Core info :
 *   - bits 0..3 = Core Major Version
 *   - bit  4..7 = Core Minor Version
 */

/* Core */
#define ELF_KVX_CORE_BIT_SHIFT  (8)
#define ELF_KVX_CORE_MASK       (0x7f<<ELF_KVX_CORE_BIT_SHIFT)

#define ELF_KVX_CORE_MAJOR_MASK (0x0F << ELF_KVX_CORE_BIT_SHIFT)
#define ELF_KVX_CORE_MINOR_MASK (0xF0 << ELF_KVX_CORE_BIT_SHIFT)
#define ELF_KVX_CORE_MINOR_SHIFT (4 + ELF_KVX_CORE_BIT_SHIFT)

#define ELF_KVX_CORE_KV3         (0x03 << ELF_KVX_CORE_BIT_SHIFT)

#define ELF_KVX_CORE_KV3_1      (ELF_KVX_CORE_KV3 | (1 << (ELF_KVX_CORE_MINOR_SHIFT)))
#define ELF_KVX_CORE_KV3_2      (ELF_KVX_CORE_KV3 | (2 << (ELF_KVX_CORE_MINOR_SHIFT)))

#define ELF_KVX_IS_KV3(flags)   (((flags) & ELF_KVX_CORE_MAJOR_MASK) == (ELF_KVX_CORE_KV3))
#define ELF_KVX_CHECK_CORE(flags,m) (((flags) & ELF_KVX_CORE_MASK)==(m))

#define ELF_KVX_ABI_MASK         (0xFF)

#define ELF_KVX_ABI_IDENT_MASK   (0x7)
#define ELF_KVX_ABI_REGULAR      (0x1)
#define ELF_KVX_ABI_UNDEF        (0x0)

#define ELF_KVX_ABI_64B_ADDR_BIT (0x08)

#define ELF_KVX_ABI_PIC_BIT      (0x10)

#endif /* _KV3_ELFIDS_H_ */
